package ProjectTankHard;

import ProjectTankHard.DrawningObjects.DrawningTankBase;
import ProjectTankHard.DrawningObjects.DrawningWheels;
import ProjectTankHard.DrawningObjects.IDraw;
import ProjectTankHard.Entities.EntityTankBase;
import ProjectTankHard.Generics.HardGeneric;

import javax.swing.*;
import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.Random;

public class FormHard {
    private Canvas canv;
    private int pictureBoxWidth;
    private int pictureBoxHeight;
    private EntityTankBase createEntity(){
        Random random = new Random();
        return new EntityTankBase(random.nextInt(100, 300),
                random.nextDouble(1000, 3000),
                Color.getHSBColor(random.nextInt(0, 301), random.nextInt(0, 301), random.nextInt(0, 301)));
    }
    void Draw(){
        if(canv == null) return;
        canv.repaint();
    }
    private IDraw makeIDraw(){
        Random random = new Random();
        return new DrawningWheels(pictureBoxWidth, pictureBoxHeight, 0, 0,
                Color.getHSBColor(random.nextInt(0, 301), random.nextInt(0, 301), random.nextInt(0, 301)));
    }
    public FormHard(){
        Random rand = new Random();
        int hardGenericSize = rand.nextInt(1, 10);

        JFrame HardFrame = new JFrame();
        HardFrame.setSize(700, 400);
        HardFrame.setDefaultCloseOperation(WindowConstants.EXIT_ON_CLOSE);

        canv = new Canvas();
        canv.setBounds(0,0,pictureBoxWidth,pictureBoxHeight);

        JButton MakeObjectButton = new JButton("Создать");
        MakeObjectButton.setBounds(0, 0, 100, 40);

        HardFrame.setContentPane(canv);
        HardFrame.setVisible(true);

        canv.add(MakeObjectButton);
        pictureBoxHeight = canv.getHeight();
        pictureBoxWidth = canv.getWidth();

        HardGeneric<EntityTankBase, IDraw> hardGeneric = new HardGeneric<>(hardGenericSize, hardGenericSize, pictureBoxWidth, pictureBoxHeight);

        for(int i = 0; i < hardGenericSize; i++){
            EntityTankBase entity = createEntity();
            hardGeneric.InsertFirst(entity);
            hardGeneric.InsertSecond(makeIDraw());
        }

        MakeObjectButton.addActionListener(
            new ActionListener() {
                @Override
                public void actionPerformed(ActionEvent e) {
                    DrawningTankBase DrawningTankBase = hardGeneric.MakeObject();
                    DrawningTankBase.SetPosition(pictureBoxWidth / 2 - DrawningTankBase.GetWidth()/2,
                            pictureBoxHeight / 2 - DrawningTankBase.GetHeight()/2);
                    canv.DrawningTankBase = DrawningTankBase;
                    Draw();
                }
            }
        );
    }
}

